package de.intevation.gnv.exports;

import java.util.List;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import de.intevation.gnv.geobackend.base.Result;
import de.intevation.gnv.geobackend.base.ResultDescriptor;
import de.intevation.gnv.state.exception.StateException;


/**
 * @author Ingo Weinzierl (ingo.weinzierl@intevation.de)
 */
public class DefaultDataCollector
implements Export.DataCollector
{
    private   Logger log = Logger.getLogger(DefaultDataCollector.class);

    protected ResultDescriptor rd;
    protected String []        names;


    public DefaultDataCollector(String[] names) {
        this.names = names;
    }

    public void init(Result res) {
        rd = res.getResultDescriptor();
    }

    public String[] getData(Result result)
    throws StateException {

        if (rd == null)
            init(result);

        List entries = new ArrayList();

        int[] indices = rd.getColumnIndices(names);
        for (int i = 0; i < names.length; ++i) {
            entries.add(result.getString(indices[i]));
        }

        return (String[]) entries.toArray((new String[entries.size()]));
    }
}
